Index: /palm/trunk/SOURCE/modules.f90
===================================================================
--- /palm/trunk/SOURCE/modules.f90	(revision 1319)
+++ /palm/trunk/SOURCE/modules.f90	(revision 1320)
@@ -20,5 +20,11 @@
 ! Current revisions:
 ! ------------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! old module precision_kind is removed,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -210,196 +216,4 @@
 ! for thread-safe summation in advec_ws.
 !
-! 792 2011-12-01 01:23:23Z raasch
-! particle arrays (particles, parrticles_temp) implemented as pointers,
-! +particles_1, particles_2, sort_count
-!
-! 790 2011-11-29 03:11:20Z raasch
-! +turbulence_effects_on_collision, wang_collision_kernel
-!
-! 785 2011-11-28 09:47:19Z raasch
-! +scalar_rayleigh_damping, rdf_sc
-!
-! 778 2011-11-07 14:18:25Z fricke
-! +gathered_size, subdomain_size
-!
-! 771 2011-10-27 10:56:21Z heinze
-! +lpt_av
-!
-! 767 2011-10-14 06:39:12Z raasch
-! +u_profile, v_profile, uv_heights, use_prescribed_profile_data
-!
-! 759 2011-09-15 13:58:31Z raasch
-! +io_blocks, io_group, maximum_parallel_io_streams,
-! synchronous_exchange moved to control_parameters
-!
-! 743 2011-08-18 16:10:16Z suehring
-! Dimension of sums_wsus_ws_l, sums_wsvs_ws_l, sums_us2_ws_l, sums_vs2_ws_l, 
-! sums_ws2_ws_l, sums_wspts_ws_l, sums_wssas_ws_l,sums_wsqs_ws_l needed for 
-! statistical evaluation of turbulent fluxes in WS-scheme decreased.
-! 736 2011-08-17 14:13:26Z suehring
-! Dimension of fluxes needed for WS-scheme increased. 
-!
-! 722 2011-04-11 06:21:09Z raasch
-! Bugfix: default value for south_border_pe changed to .F.
-!
-! 707 2011-03-29 11:39:40Z raasch
-! +bc_lr_dirrad, bc_lr_raddir, bc_ns_dirrad, bc_ns_raddir, left_border_pe,
-! north_border_pe, right_border_pe, south_border_pe
-! p_sub renamed p_loc
-!
-! 683 2011-02-09 14:25:15Z raasch
-! +synchronous_exchange
-!
-! 673 2011-01-18 16:19:48Z suehring
-! +weight_pres to weight the respective contribution of the Runge-Kutta 
-! substeps. +p_sub to buffer the intermediate contributions for Multigrid and 
-! SOR.
-!
-! 667 2010-12-23 12:06:00Z suehring/gryschka
-! Removed u_nzb_p1_for_vfc and v_nzb_p1_for_vfc
-! For coupling with different resolution in ocean and atmophere:
-! +nx_a, +nx_o, ny_a, +ny_o, ngp_a, ngp_o, +total_2d_o, +total_2d_a,
-! +coupling_topology 
-! Buffer arrays for the left sided advective fluxes added in arrays_3d.
-! +flux_s_u, +flux_s_v, +flux_s_w, +diss_s_u, +diss_s_v, +diss_s_w,
-! +flux_s_pt, +diss_s_pt, +flux_s_e, +diss_s_e, +flux_s_q, +diss_s_q,
-! +flux_s_sa, +diss_s_sa
-! 3d arrays for dissipation control added. (only necessary for vector arch.)
-! +var_x, +var_y, +var_z, +gamma_x, +gamma_y, +gamma_z
-! Default of momentum_advec and scalar_advec changed to 'ws-scheme' .
-! +exchange_mg added in control_parameters to steer the data exchange.
-! Parameters +nbgp, +nxlg, +nxrg, +nysg, +nyng added in indices.
-! flag array +boundary_flags added in indices to steer the degradation of order 
-! of the advective fluxes when non-cyclic boundaries are used.
-! MPI-datatypes +type_y, +type_y_int and +type_yz for data_exchange added in 
-! pegrid.
-! +sums_wsus_ws_l, +sums_wsvs_ws_l, +sums_us2_ws_l, +sums_vs2_ws_l, 
-! +sums_ws2_ws_l, +sums_wspts_ws_l, +sums_wssas_ws_l, +sums_wsqs_ws_l 
-! and +weight_substep added in statistics to steer the statistical evaluation 
-! of turbulent fluxes in the advection routines.
-! LOGICALS +ws_scheme_sca and +ws_scheme_mom added to get a better performance
-! in prognostic_equations.
-! LOGICAL +dissipation_control control added to steer numerical dissipation
-! in ws-scheme.
-! Changed length of string run_description_header
-!
-! 622 2010-12-10 08:08:13Z raasch
-! +collective_wait in pegrid
-!
-! 600 2010-11-24 16:10:51Z raasch
-! default values of surface_scalarflux and surface_waterflux changed
-! to 9999999.9
-!
-! 580 2010-10-05 13:59:11Z heinze
-! Renaming of ws_vertical_gradient to subs_vertical_gradient,
-! ws_vertical_gradient_level to subs_vertical_gradient_level and
-! ws_vertical_gradient_level_ind to subs_vertical_gradient_level_i
-!
-! 564 2010-09-30 13:18:59Z helmke
-! nc_precision and netcdf_precision dimension changed to 11, all default 
-! values of mask_xyz_loop changed to -1.0, dimension of openfile changed to 
-! 200+2*max_masks, max_masks changed to 50
-!
-! 553 2010-09-01 14:09:06Z weinreis
-! parameters for masked output are replaced by arrays
-!
-! 531 2010-04-21 06:47:21Z heinze
-! character length of dopr_unit enlarged
-!
-! 519 2010-03-19 05:30:02Z raasch
-! -replace_char, replace_by
-!
-! 493 2010-03-01 08:30:24Z raasch
-! +netcdf_data_format, -netcdf_64bit, -netcdf_64bit_3d, -netcdf_format_mask*,
-! -nc_format_mask, -format_parallel_io
-!
-! 485 2010-02-05 10:57:51Z raasch
-! ngp_3d, ngp_3d_inner changed to 64 bit
-!
-! 449 2010-02-02 11:23:59Z raasch
-! -var_ts: replaced by dots_max,
-! initial data assignments to some dvrp arrays changed due to error messages
-! from gfortran compiler
-! +large_scale_subsidence, ws_vertical_gradient, ws_vertical_gradient_level,
-! ws_vertical_gradient_level_ind, w_subs
-!
-! 388 2009-09-23 09:40:33Z raasch
-! +prho, prho_1
-! +bc_lr_cyc, bc_ns_cyc
-! +output_for_t0 
-! translation error of actual -> current revisions fixed
-! +q* in dots_label, dots_unit. increased dots_num respectively
-! typographical error in dots_unit fixed
-! +clip_dvrp_*, cluster_size, color_interval, dvrpsize_interval, dvrp_overlap,
-! dvrp_total_overlap, groundplate_color, local_dvrserver_running, n*_dvrp,
-! interval_*_dvrp_prt, isosurface_color, particle_color, particle_dvrpsize,
-! topography color in dvrp_variables,
-! vertical_particle_advection is a 1d-array,
-! +canyon_height, canyon_width_x, canyon_width_y, canyon_wall_left, 
-! canyon_wall_south, conserve_volume_flow_mode, coupling_start_time,
-! dp_external, dp_level_b, dp_level_ind_b, dp_smooth, dp_smooth_factor, dpdxy,
-! run_coupled, time_since_reference_point, u_bulk, v_bulk in control_parameters,
-! default value of grid_matching changed to strict
-! +shf_av, qsws_av
-!
-! 217 2008-12-09 18:00:48Z letzel
-! +topography_grid_convention
-! some dvrp-variables changed to single precision, variables for dvrp-mode
-! pathlines added, +target_id, abort_mode, message_string
-!
-! 197 2008-09-16 15:29:03Z raasch
-! allow 100 spectra levels instead of 10 for consistency with 
-! define_netcdf_header, +canopy_heat_flux, cthf, lai,
-! +leaf_surface_concentration, scalar_exchange_coefficient, sec, sls
-! +hor_index_bounds, hor_index_bounds_previous_run, id_inflow, id_recycling,
-! inflow_damping_*, mean_inflow_profiles, numprocs_previous_run, nx_on_file,
-! ny_on_file, offset_ocean_*, recycling_plane, recycling_width, turbulent_inflow
-! -myid_char_14
-!
-! 138 2007-11-28 10:03:58Z letzel
-! +drag_coefficient, pch_index, lad_surface, lad_vertical_gradient, 
-! lad_vertical_gradient_level, plant_canopy, lad, lad_s, lad_u, lad_v, 
-! lad_w, cdc, lad_vertical_gradient_level_ind, canopy_mode
-! +dt_sort_particles, ngp_2dh_s_inner, time_sort_particles, flags, 
-! wall_flags_1..10, wall_humidityflux(0:4), wall_qflux(0:4), 
-! wall_salinityflux(0:4), wall_scalarflux(0:4)
-!
-! 108 2007-08-24 15:10:38Z letzel
-! +comm_inter, constant_top_momentumflux, coupling_char, coupling_mode,
-! coupling_mode_remote, c_u, c_v, c_w, dt_coupling, e_init, humidity_remote, 
-! ngp_xy, nxlu, nysv, port_name, qswst_remote, terminate_coupled, 
-! terminate_coupled_remote, time_coupling, top_momentumflux_u|v, type_xy, 
-! uswst*, vswst*
-!
-! 97 2007-06-21 08:23:15Z raasch
-! +atmos_ocean_sign, ocean, r, + salinity variables
-! defaults of .._vertical_gradient_levels changed from -1.0 to -9999999.9
-! hydro_press renamed hyp, use_pt_reference renamed use_reference
-!
-! 89 2007-05-25 12:08:31Z raasch
-! +data_output_pr_user, max_pr_user, size of data_output_pr, dopr_index,
-! dopr_initial_index and dopr_unit enlarged,
-! var_hom and var_sum renamed pr_palm
-!
-! 82 2007-04-16 15:40:52Z raasch
-! +return_addres, return_username
-! Cpp-directive lcmuk renamed lc
-!
-! 75 2007-03-22 09:54:05Z raasch
-! +arrays precipitation_amount, precipitation_rate, precipitation_rate_av,
-! rif_wall, z0_av, +arrays u_m_l, u_m_r, etc. for radiation boundary conditions,
-! +loop_optimization, netcdf_64bit_3d, zu_s_inner, zw_w_inner, id_var_zusi_*,
-! id_var_zwwi_*, ts_value, u_nzb_p1_for_vfc, v_nzb_p1_for_vfc, pt_reference,
-! use_pt_reference, precipitation_amount_interval, revision
-! +age_m in particle_type, moisture renamed humidity,
-! -data_output_ts, dots_n, uvmean_outflow, uxrp, vynp,
-! arrays dots_label and dots_unit now dimensioned with dots_max,
-! setting of palm version moved to main program
-!
-! 37 2007-03-01 08:33:54Z raasch
-! +constant_top_heatflux, top_heatflux, use_top_fluxes, +arrays for top fluxes,
-! +nzt_diff, default of bc_pt_t renamed "initial_gradient"
-! Bugfix: p is not a pointer
-!
 ! RCS Log replace by Id keyword, revision history cleaned up
 !
@@ -415,6 +229,7 @@
 ! Definition of variables for special advection schemes
 !------------------------------------------------------------------------------!
-
-    REAL, DIMENSION(:), ALLOCATABLE   ::  aex, bex, dex, eex
+    USE kinds
+
+    REAL(wp), DIMENSION(:), ALLOCATABLE   ::  aex, bex, dex, eex
 
     SAVE
@@ -425,23 +240,4 @@
 
 
- MODULE precision_kind
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-! Definition of type parameters (used for the definition of single or double
-! precision variables)
-!------------------------------------------------------------------------------!
-
-    INTEGER, PARAMETER ::  dpk = SELECTED_REAL_KIND( 12 ), &
-                           spk = SELECTED_REAL_KIND( 6 )
-
-    SAVE
-
- END MODULE precision_kind
-
-
-
-
  MODULE arrays_3d
 
@@ -452,7 +248,7 @@
 !------------------------------------------------------------------------------!
 
-    USE precision_kind
-
-    REAL, DIMENSION(:), ALLOCATABLE ::                                         &
+    USE kinds
+
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::                                     &
           c_u_m, c_u_m_l, c_v_m, c_v_m_l, c_w_m, c_w_m_l, ddzu, ddzu_pres,     &
           dd2zu, dzu, ddzw, dzw, hyp, inflow_damping_factor, lad, l_grid,      &
@@ -462,5 +258,5 @@
           u_init, u_nzb_p1_for_vfc, vg, v_init, v_nzb_p1_for_vfc, w_subs, zu, zw
 
-    REAL, DIMENSION(:,:), ALLOCATABLE ::                                       &
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::                                   &
           c_u, c_v, c_w, diss_s_e, diss_s_nr, diss_s_pt, diss_s_q,             &
           diss_s_qr, diss_s_sa, diss_s_u, diss_s_v, diss_s_w, dzu_mg, dzw_mg,  &
@@ -473,5 +269,5 @@
           wnudge, wsubs_vert, z0, z0h
 
-    REAL, DIMENSION(:,:,:), ALLOCATABLE ::                                     &
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::                                 &
           canopy_heat_flux, cdc, d, de_dx, de_dy, de_dz, diss, diss_l_e,       &
           diss_l_nr, diss_l_pt, diss_l_q, diss_l_qr, diss_l_sa, diss_l_u,      &
@@ -483,15 +279,15 @@
 
 #if defined( __nopointer )
-    REAL, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::                             &
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::                         &
           e, e_p, nr, nr_p, p, prho, pt, pt_p, q, q_p, qc, ql, ql_c, ql_v,     &
           ql_vp, qr, qr_p, rho, sa, sa_p, te_m, tnr_m, tpt_m, tq_m, tqr_m,     &
           tsa_m, tu_m, tv_m, tw_m, u, u_p, v, v_p, vpt, w, w_p
 #else
-    REAL, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::                             &
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::                         &
           e_1, e_2, e_3, p, prho_1, nr_1, nr_2, nr_3, pt_1, pt_2, pt_3, q_1,   &
           q_2, q_3, qc_1, ql_v, ql_vp, ql_1, ql_2, qr_1, qr_2, qr_3, rho_1,    &
           sa_1, sa_2, sa_3, u_1, u_2, u_3, v_1, v_2, v_3, vpt_1, w_1, w_2, w_3
 
-    REAL, DIMENSION(:,:,:), POINTER ::                                         &
+    REAL(wp), DIMENSION(:,:,:), POINTER ::                                     &
           e, e_p, nr, nr_p, prho, pt, pt_p, q, q_p, qc, ql, ql_c, qr, qr_p,    &
           rho, sa, sa_p, te_m, tnr_m, tpt_m, tq_m, tqr_m, tsa_m, tu_m, tv_m,   &
@@ -499,7 +295,7 @@
 #endif
 
-    REAL, DIMENSION(:,:,:,:), ALLOCATABLE ::  rif_wall, tri
-
-    REAL, DIMENSION(:,:,:), ALLOCATABLE :: var_x, var_y, var_z, gamma_x,       &
+    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  rif_wall, tri
+
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: var_x, var_y, var_z, gamma_x,   &
                                            gamma_y, gamma_z
 
@@ -519,10 +315,11 @@
 ! Definition of variables needed for time-averaging of 2d/3d data
 !------------------------------------------------------------------------------!
-
-    REAL, DIMENSION(:,:), ALLOCATABLE ::  lwp_av, precipitation_rate_av,       &
+    USE kinds
+
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  lwp_av, precipitation_rate_av,   &
                                           qsws_av, shf_av,ts_av, us_av, z0_av, &
                                           z0h_av
 
-    REAL, DIMENSION(:,:,:), ALLOCATABLE, TARGET :: &
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::                         &
           e_av, lpt_av, nr_av, p_av, pc_av, pr_av, prr_av, pt_av, q_av, qc_av, &
           ql_av, ql_c_av, ql_v_av, ql_vp_av, qr_av, qv_av, rho_av, s_av, sa_av,&
@@ -540,4 +337,5 @@
 ! Definition of variables and constants for cloud physics
 !------------------------------------------------------------------------------!
+    USE kinds
 
     LOGICAL ::  curvature_solution_effects = .FALSE., &
@@ -546,72 +344,72 @@
                 
 
-    REAL ::  a_1 = 8.69E-4,     & ! coef. in turb. parametrization (cm-2 s3)
-             a_2 = -7.38E-5,    & ! coef. in turb. parametrization (cm-2 s3)
-             a_3 = -1.40E-2,    & ! coef. in turb. parametrization
-             a_term = 9.65,     & ! coef. for terminal velocity (m s-1)
-             a_vent = 0.78,     & ! coef. for ventilation effect
-             b_1 = 11.45E-6,    & ! coef. in turb. parametrization (m)
-             b_2 = 9.68E-6,     & ! coef. in turb. parametrization (m)
-             b_3 = 0.62,        & ! coef. in turb. parametrization
-             b_term = 9.8,      & ! coef. for terminal velocity (m s-1)
-             b_vent = 0.308,    & ! coef. for ventilation effect
-             beta_cc = 3.09E-4, & ! coef. in turb. parametrization (cm-2 s3)
-             bfactor,           &
-             c_1 = 4.82E-6,     & ! coef. in turb. parametrization (m)
-             c_2 = 4.8E-6,      & ! coef. in turb. parametrization (m)
-             c_3 = 0.76,        & ! coef. in turb. parametrization
-             c_const = 0.93,    & ! const. in Taylor-microscale Reynolds number
-             c_evap = 0.7,      & ! constant in evaporation
-             c_sedimentation = 2.0, & ! Courant number of sedimentation process
-             c_term = 600.0,    & ! coef. for terminal velocity (m-1)
-             cof(6) = (/ 76.18009172947146,      & ! coefficients in the 
-                         -86.50532032941677,     & ! numerical
-                         24.01409824083091,      & ! calculation of the
-                         -1.231739572450155,     & ! gamma function
-                         0.1208650973866179E-2,  &
-                         -0.5395239384953E-5 /), &
-             cp = 1005.0,       & ! heat capacity of dry air (J kg-1 K-1) 
-             diff_coeff_l = 0.23E-4, & ! diffusivity of water vapor (m2 s-1)
-             effective_coll_efficiency, &
-             eps_ros = 1.0E-4,  & ! accuracy of Rosenbrock method
-             eps_sb = 1.0E-20,  & ! threshold in two-moments scheme
-             k_cc = 9.44E09,    & ! const. cloud-cloud kernel (m3 kg-2 s-1) 
-             k_cr0 = 4.33,      & ! const. cloud-rain kernel (m3 kg-1 s-1) 
-             k_rr = 7.12,       & ! const. rain-rain kernel (m3 kg-1 s-1) 
-             k_br = 1000.,      & ! const. in breakup parametrization (m-1)
-             k_st = 1.2E8,      & ! const. in drizzle parametrization (m-1 s-1)
-             kappa_rr = 60.7,   & ! const. in collision kernel (kg-1/3)
-             kin_vis_air = 1.4086E-5, & ! kin. viscosity of air (m2 s-1)
-             l_v = 2.5E+06,     & ! latent heat of vaporization (J kg-1)
-             l_d_cp, l_d_r, l_d_rv, & ! l_v / cp, l_v / r_d, l_v / r_v
-             mass_of_solute = 1.0E-17, & ! soluted NaCl (kg)
-             molecular_weight_of_solute = 0.05844, & ! mol. m. NaCl (kg mol-1)
-             molecular_weight_of_water = 0.01801528, & ! mol. m. H2O (kg mol-1)
-             nc_const = 70.0E6, & ! cloud droplet concentration
-             prec_time_const = 0.001, & !coef. in Kessler scheme
-             pirho_l, dpirho_l, & ! pi * rho_l / 6.0; 6.0 / ( pi * rho_l )
-             rho_l = 1.0E3,     & ! density of water (kg m-3)
-             ql_crit = 0.0005,  & ! coef. in Kessler scheme
-             r_d = 287.0,       & ! sp. gas const. dry air (J kg-1 K-1)
-             r_v = 461.51,      & ! sp. gas const. water vapor (J kg-1 K-1)
-             schmidt = 0.71,    & ! Schmidt number
-             schmidt_p_1d3,     & ! schmidt**( 1.0 / 3.0 )
-             sigma_gc = 1.3,    & ! log-normal geometric standard deviation
-             stp = 2.5066282746310005, & ! parameter in gamma function
-             thermal_conductivity_l = 2.43E-2, & ! therm. cond. air (J m-1 s-1 K-1)
-             vanthoff = 2.0,    & ! van't Hoff factor for NaCl
-             x0 = 2.6E-10,      & ! separating drop mass (kg)
-             xrmin = 2.6E-10,   & ! minimum rain drop size (kg)
-             xrmax = 5.0E-6,    & ! maximum rain drop site (kg)
-             dt_precipitation = 100.0, & ! timestep precipitation (s)
-             w_precipitation = 9.65      ! maximum terminal velocity (m s-1)
-
-    REAL, DIMENSION(:), ALLOCATABLE     ::  hyrho, pt_d_t, t_d_pt  
-
-    REAL, DIMENSION(:,:), ALLOCATABLE   ::  precipitation_amount, &
-                                            precipitation_rate
+    REAL(wp) ::  a_1 = 8.69E-4,     & !: coef. in turb. parametrization (cm-2 s3)
+                 a_2 = -7.38E-5,    & !: coef. in turb. parametrization (cm-2 s3)
+                 a_3 = -1.40E-2,    & !: coef. in turb. parametrization
+                 a_term = 9.65,     & !: coef. for terminal velocity (m s-1)
+                 a_vent = 0.78,     & !: coef. for ventilation effect
+                 b_1 = 11.45E-6,    & !: coef. in turb. parametrization (m)
+                 b_2 = 9.68E-6,     & !: coef. in turb. parametrization (m)
+                 b_3 = 0.62,        & !: coef. in turb. parametrization
+                 b_term = 9.8,      & !: coef. for terminal velocity (m s-1)
+                 b_vent = 0.308,    & !: coef. for ventilation effect
+                 beta_cc = 3.09E-4, & !: coef. in turb. parametrization (cm-2 s3)
+                 bfactor,           &
+                 c_1 = 4.82E-6,     & !: coef. in turb. parametrization (m)
+                 c_2 = 4.8E-6,      & !: coef. in turb. parametrization (m)
+                 c_3 = 0.76,        & !: coef. in turb. parametrization
+                 c_const = 0.93,    & !: const. in Taylor-microscale Reynolds number
+                 c_evap = 0.7,      & !: constant in evaporation
+                 c_sedimentation = 2.0, & !: Courant number of sedimentation process
+                 c_term = 600.0,    & !: coef. for terminal velocity (m-1)
+                 cof(6) = (/ 76.18009172947146,      & !: coefficients in the 
+                             -86.50532032941677,     & !: numerical
+                             24.01409824083091,      & !: calculation of the
+                             -1.231739572450155,     & !: gamma function
+                             0.1208650973866179E-2,  &
+                             -0.5395239384953E-5 /), &
+                cp = 1005.0,       & !: heat capacity of dry air (J kg-1 K-1) 
+                diff_coeff_l = 0.23E-4, & !: diffusivity of water vapor (m2 s-1)
+                effective_coll_efficiency, & !:
+                eps_ros = 1.0E-4,  & !: accuracy of Rosenbrock method
+                eps_sb = 1.0E-20,  & !: threshold in two-moments scheme
+                k_cc = 9.44E09,    & !: const. cloud-cloud kernel (m3 kg-2 s-1) 
+                k_cr0 = 4.33,      & !: const. cloud-rain kernel (m3 kg-1 s-1) 
+                k_rr = 7.12,       & !: const. rain-rain kernel (m3 kg-1 s-1) 
+                k_br = 1000.,      & !: const. in breakup parametrization (m-1)
+                k_st = 1.2E8,      & !: const. in drizzle parametrization (m-1 s-1)
+                kappa_rr = 60.7,   & !: const. in collision kernel (kg-1/3)
+                kin_vis_air = 1.4086E-5, & !: kin. viscosity of air (m2 s-1)
+                l_v = 2.5E+06,     & !: latent heat of vaporization (J kg-1)
+                l_d_cp, l_d_r, l_d_rv, & !: l_v / cp, l_v / r_d, l_v / r_v
+                mass_of_solute = 1.0E-17, & !: soluted NaCl (kg)
+                molecular_weight_of_solute = 0.05844, & !: mol. m. NaCl (kg mol-1)
+                molecular_weight_of_water = 0.01801528, & !: mol. m. H2O (kg mol-1)
+                nc_const = 70.0E6, & !: cloud droplet concentration
+                prec_time_const = 0.001, & !: coef. in Kessler scheme
+                pirho_l, dpirho_l, & !: pi * rho_l / 6.0; 6.0 / ( pi * rho_l )
+                rho_l = 1.0E3,     & !: density of water (kg m-3)
+                ql_crit = 0.0005,  & !: coef. in Kessler scheme
+                r_d = 287.0,       & !: sp. gas const. dry air (J kg-1 K-1)
+                r_v = 461.51,      & !: sp. gas const. water vapor (J kg-1 K-1)
+                schmidt = 0.71,    & !: Schmidt number
+                schmidt_p_1d3,     & !: schmidt**( 1.0 / 3.0 )
+                sigma_gc = 1.3,    & !: log-normal geometric standard deviation
+                stp = 2.5066282746310005, & !: parameter in gamma function
+                thermal_conductivity_l = 2.43E-2, & !: therm. cond. air (J m-1 s-1 K-1)
+                vanthoff = 2.0,    & !: van't Hoff factor for NaCl
+                x0 = 2.6E-10,      & !: separating drop mass (kg)
+                xrmin = 2.6E-10,   & !: minimum rain drop size (kg)
+                xrmax = 5.0E-6,    & !: maximum rain drop site (kg)
+                dt_precipitation = 100.0, & !: timestep precipitation (s)
+                w_precipitation = 9.65      !: maximum terminal velocity (m s-1)
+
+    REAL(wp), DIMENSION(:), ALLOCATABLE     ::  hyrho, pt_d_t, t_d_pt  
+
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE   ::  precipitation_amount, &
+                                                precipitation_rate
 !
 !-- 3D array of precipitation rate
-    REAL, DIMENSION(:,:,:), ALLOCATABLE ::  prr
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  prr
 
     SAVE
@@ -629,7 +427,8 @@
 ! Definition of general constants
 !------------------------------------------------------------------------------!
-
-    REAL    ::  pi = 3.141592654
-    REAL    ::  adv_mom_1, adv_mom_3, adv_mom_5, adv_sca_1, adv_sca_3, adv_sca_5
+    USE kinds
+
+    REAL(wp)  ::  pi = 3.141592654_wp
+    REAL(wp)  ::  adv_mom_1, adv_mom_3, adv_mom_5, adv_sca_1, adv_sca_3, adv_sca_5
     
 
@@ -648,8 +447,9 @@
 ! Definition of parameters for program control
 !------------------------------------------------------------------------------!
+    USE kinds
 
     TYPE plot_precision
        CHARACTER (LEN=8) ::  variable
-       INTEGER           ::  precision
+       INTEGER(iwp)      ::  precision
     END TYPE plot_precision
 
@@ -722,59 +522,59 @@
     CHARACTER (LEN=10), DIMENSION(0:1,100) ::  do2d = ' ', do3d = ' '
 
-    INTEGER ::  abort_mode = 1, average_count_pr = 0, average_count_sp = 0, &
-                average_count_3d = 0, current_timestep_number = 0, &
-                coupling_topology = 0, &
-                dist_range = 0, disturbance_level_ind_b, &
-                disturbance_level_ind_t, doav_n = 0, dopr_n = 0, &
-                dopr_time_count = 0, dopts_time_count = 0, &
-                dosp_time_count = 0, dots_time_count = 0, &
-                do2d_xy_n = 0, do2d_xz_n = 0, do2d_yz_n = 0, do3d_avs_n = 0, &
-                dp_level_ind_b = 0, dvrp_filecount = 0, &
-                dz_stretch_level_index, gamma_mg, gathered_size, &
-                grid_level, ibc_e_b, ibc_p_b, ibc_p_t, &
-                ibc_pt_b, ibc_pt_t, ibc_q_b, ibc_q_t, &
-                ibc_sa_t, ibc_uv_b, ibc_uv_t, icloud_scheme, &
-                inflow_disturbance_begin = -1, inflow_disturbance_end = -1, &
-                intermediate_timestep_count, intermediate_timestep_count_max, &
-                io_group = 0, io_blocks = 1, iran = -1234567, &
-                masks = 0, maximum_grid_level, &
-                maximum_parallel_io_streams = -1, max_pr_user = 0, &
-                mgcycles = 0, mg_cycles = -1, mg_switch_to_pe0_level = 0, mid, &
-                nlsf = 1000, ntnudge = 100, netcdf_data_format = 2, ngsrb = 2, &
-                nr_timesteps_this_run = 0, &
-                nsor = 20, nsor_ini = 100, n_sor, normalizing_region = 0, &
-                nz_do3d = -9999, pch_index = 0, prt_time_count = 0, &
-                recycling_plane, runnr = 0, &
-                skip_do_avs = 0, subdomain_size, terminate_coupled = 0, &
-                terminate_coupled_remote = 0, timestep_count = 0
-
-    INTEGER ::  dist_nxl(0:1), dist_nxr(0:1), dist_nyn(0:1), dist_nys(0:1), &
-                do2d_no(0:1) = 0, do2d_xy_time_count(0:1), &
-                do2d_xz_time_count(0:1), do2d_yz_time_count(0:1), &
-                do3d_no(0:1) = 0, do3d_time_count(0:1), &
-                domask_no(max_masks,0:1) = 0, domask_time_count(max_masks,0:1),&
-                lad_vertical_gradient_level_ind(10) = -9999, &
-                mask_size(max_masks,3) = -1, mask_size_l(max_masks,3) = -1, &
-                mask_start_l(max_masks,3) = -1, &
-                pt_vertical_gradient_level_ind(10) = -9999, &
-                q_vertical_gradient_level_ind(10) = -9999, &
-                sa_vertical_gradient_level_ind(10) = -9999, &
-                section(100,3), section_xy(100) = -9999, &
-                section_xz(100) = -9999, section_yz(100) = -9999, &
-                ug_vertical_gradient_level_ind(10) = -9999, &
-                vg_vertical_gradient_level_ind(10) = -9999, &
-                subs_vertical_gradient_level_i(10) = -9999
+    INTEGER(iwp) ::  abort_mode = 1, average_count_pr = 0, average_count_sp = 0, &
+                     average_count_3d = 0, current_timestep_number = 0, &
+                     coupling_topology = 0, &
+                     dist_range = 0, disturbance_level_ind_b, &
+                     disturbance_level_ind_t, doav_n = 0, dopr_n = 0, &
+                     dopr_time_count = 0, dopts_time_count = 0, &
+                     dosp_time_count = 0, dots_time_count = 0, &
+                     do2d_xy_n = 0, do2d_xz_n = 0, do2d_yz_n = 0, do3d_avs_n = 0, &
+                     dp_level_ind_b = 0, dvrp_filecount = 0, &
+                     dz_stretch_level_index, gamma_mg, gathered_size, &
+                     grid_level, ibc_e_b, ibc_p_b, ibc_p_t, &
+                     ibc_pt_b, ibc_pt_t, ibc_q_b, ibc_q_t, &
+                     ibc_sa_t, ibc_uv_b, ibc_uv_t, icloud_scheme, &
+                     inflow_disturbance_begin = -1, inflow_disturbance_end = -1, &
+                     intermediate_timestep_count, intermediate_timestep_count_max, &
+                     io_group = 0, io_blocks = 1, iran = -1234567, &
+                     masks = 0, maximum_grid_level, &
+                     maximum_parallel_io_streams = -1, max_pr_user = 0, &
+                     mgcycles = 0, mg_cycles = -1, mg_switch_to_pe0_level = 0, mid, &
+                     nlsf = 1000, ntnudge = 100, netcdf_data_format = 2, ngsrb = 2, &
+                     nr_timesteps_this_run = 0, &
+                     nsor = 20, nsor_ini = 100, n_sor, normalizing_region = 0, &
+                     nz_do3d = -9999, pch_index = 0, prt_time_count = 0, &
+                     recycling_plane, runnr = 0, &
+                     skip_do_avs = 0, subdomain_size, terminate_coupled = 0, &
+                     terminate_coupled_remote = 0, timestep_count = 0
+
+    INTEGER(iwp) ::  dist_nxl(0:1), dist_nxr(0:1), dist_nyn(0:1), dist_nys(0:1), &
+                     do2d_no(0:1) = 0, do2d_xy_time_count(0:1), &
+                     do2d_xz_time_count(0:1), do2d_yz_time_count(0:1), &
+                     do3d_no(0:1) = 0, do3d_time_count(0:1), &
+                     domask_no(max_masks,0:1) = 0, domask_time_count(max_masks,0:1),&
+                     lad_vertical_gradient_level_ind(10) = -9999, &
+                     mask_size(max_masks,3) = -1, mask_size_l(max_masks,3) = -1, &
+                     mask_start_l(max_masks,3) = -1, &
+                     pt_vertical_gradient_level_ind(10) = -9999, &
+                     q_vertical_gradient_level_ind(10) = -9999, &
+                     sa_vertical_gradient_level_ind(10) = -9999, &
+                     section(100,3), section_xy(100) = -9999, &
+                     section_xz(100) = -9999, section_yz(100) = -9999, &
+                     ug_vertical_gradient_level_ind(10) = -9999, &
+                     vg_vertical_gradient_level_ind(10) = -9999, &
+                     subs_vertical_gradient_level_i(10) = -9999
 
 #if defined ( __check )
-    INTEGER :: check_restart = 0
+    INTEGER(iwp) :: check_restart = 0
 #endif
 
-    INTEGER, DIMENSION(0:1) :: ntdim_2d_xy, ntdim_2d_xz, ntdim_2d_yz, ntdim_3d
-
-    INTEGER, DIMENSION(:), ALLOCATABLE ::  grid_level_count
-
-    INTEGER, DIMENSION(:,:), ALLOCATABLE   ::  mask_i, mask_j, mask_k
-    INTEGER, DIMENSION(:,:), ALLOCATABLE   ::  &
-                mask_i_global, mask_j_global, mask_k_global
+    INTEGER(iwp), DIMENSION(0:1) :: ntdim_2d_xy, ntdim_2d_xz, ntdim_2d_yz, ntdim_3d
+
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  grid_level_count
+
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE   ::  mask_i, mask_j, mask_k
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE   ::  &
+                    mask_i_global, mask_j_global, mask_k_global
 
     LOGICAL ::  avs_output = .FALSE., &
